__author__ = 'Felipe Reyes <felipe.reyes@canonical.com>'

from charmhelpers.contrib.network import ufw
from charmhelpers.core.hookenv import (
    config,
    log,
)


def munin_format_ip(ip):
    return "^{}$".format(ip.replace('.', '\\.'))


def grant_access(address):
    log('granting access: {}'.format(address), level='DEBUG')
    ufw.grant_access(address, port=str(config('tcp-port')), proto='tcp')

    if config('udp-port') > 0:
        ufw.grant_access(address, port=str(config('udp-port')), proto='udp')


def revoke_access(address):
    log('revoking access: {}'.format(address), level='DEBUG')
    ufw.revoke_access(address, port=str(config('tcp-port')), proto='tcp')

    if config('udp-port') > 0:
        ufw.revoke_access(address, port=str(config('udp-port')), proto='udp')
